Index: issm/branches/trunk-jpl-damage/src/c/shared/Numerics/BrentSearch.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/shared/Numerics/BrentSearch.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/shared/Numerics/BrentSearch.cpp	(revision 12878)
@@ -10,11 +10,12 @@
 
 #include "./numerics.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../include/include.h"
 #include "../../io/io.h"
 #include "../../shared/shared.h"
 #include <float.h>
-
-void BrentSearch(double* psearch_scalar,double* pJ,OptPars* optpars,double (*f)(double,OptArgs*), OptArgs* optargs){
+#include <iomanip>
+
+void BrentSearch(IssmDouble* psearch_scalar,IssmDouble* pJ,OptPars* optpars,IssmDouble (*f)(IssmDouble,OptArgs*), OptArgs* optargs){
 
 	/* This routine is optimizing a given function using Brent's method
@@ -22,15 +23,15 @@
 
 	/*Intermediary*/
-	double si,gold,intervalgold,oldintervalgold;
-	double parab_num,parab_den;
-	double distance,cm_jump;
-	double fxmax,fxmin,fxbest;
-	double fx,fx1,fx2;
-	double xmax,xmin,xbest;
-	double x,x1,x2,xm;
-	double tol1,tol2,seps;
-	double tolerance=1.e-4;
-	int    maxiter,iter;
-	bool   loop=true,goldenflag;
+	IssmDouble si,gold,intervalgold,oldintervalgold;
+	IssmDouble parab_num,parab_den;
+	IssmDouble distance,cm_jump;
+	IssmDouble fxmax,fxmin,fxbest;
+	IssmDouble fx,fx1,fx2;
+	IssmDouble xmax,xmin,xbest;
+	IssmDouble x,x1,x2,xm;
+	IssmDouble tol1,tol2,seps;
+	IssmDouble tolerance = 1.e-4;
+	int        maxiter ,iter;
+	bool       loop= true,goldenflag;
 
 	/*Recover parameters:*/
@@ -43,13 +44,16 @@
 	iter=0;
 	fxmin = (*f)(xmin,optargs);
-	if (isnan(fxmin)) _error_("Function evaluation returned NaN");
-	_printf_(VerboseControl(),"\n        Iteration         x           f(x)       Tolerance         Procedure\n\n");
-	_printf_(VerboseControl(),"        %s    %12.6g  %12.6g  %s","   N/A",xmin,fxmin,"         N/A         boundary\n");
+	if (xIsNan<IssmDouble>(fxmin)) _error2_("Function evaluation returned NaN");
+	cout<<setprecision(5);
+	if(VerboseControl()) _pprintLine_("");
+	if(VerboseControl()) _pprintLine_("       Iteration         x           f(x)       Tolerance         Procedure");
+	if(VerboseControl()) _pprintLine_("");
+	if(VerboseControl()) _pprintLine_("           N/A    "<<setw(12)<<xmin<<"  "<<setw(12)<<fxmin<<"           N/A         boundary");
 	fxmax = (*f)(xmax,optargs);
-	if (isnan(fxmax)) _error_("Function evaluation returned NaN");
-	_printf_(VerboseControl(),"        %s    %12.6g  %12.6g  %s","   N/A",xmax,fxmax,"         N/A         boundary\n");
+	if (xIsNan<IssmDouble>(fxmax)) _error2_("Function evaluation returned NaN");
+	if(VerboseControl()) _pprintLine_("           N/A    "<<setw(12)<<xmax<<"  "<<setw(12)<<fxmax<<"           N/A         boundary");
 
 	/*test if jump option activated and xmin==0*/
-	if (!isnan(cm_jump) && (xmin==0) && (fxmax/fxmin)<cm_jump){
+	if (!xIsNan<IssmDouble>(cm_jump) && (xmin==0) && (fxmax/fxmin)<cm_jump){
 		*psearch_scalar=xmax;
 		*pJ=fxmax;
@@ -58,5 +62,5 @@
 
 	/*initialize optimization variables*/
-	seps=sqrt(DBL_EPSILON);    //precision of a double
+	seps=sqrt(DBL_EPSILON);    //precision of a IssmDouble
 	distance=0.0;              //new_x=old_x + distance
 	gold=0.5*(3.0-sqrt(5.0));  //gold = 1 - golden ratio
@@ -71,5 +75,5 @@
 	/*2: call the function to be evaluated*/
 	fxbest = (*f)(x,optargs);
-	if(isnan(fxbest)) _error_("Function evaluation returned NaN");
+	if(xIsNan<IssmDouble>(fxbest)) _error2_("Function evaluation returned NaN");
 	iter=iter+1;
 
@@ -84,7 +88,8 @@
 
 	/*4: print result*/
-	_printf_(VerboseControl(),"         %5i    %12.6g  %12.6g  %12.6g  %s\n",iter,xbest,fxbest,pow(pow(xbest-xm,2),0.5),"       initial");
-	if (!isnan(cm_jump) && (xmin==0) && ((fxbest/fxmin)<cm_jump)){
-		_printf_(VerboseControl(),"      optimization terminated: current x satisfies criteria 'cm_jump'=%g\n",cm_jump);
+	if(VerboseControl())
+	 _pprintLine_("         "<<setw(5)<<iter<<"    "<<setw(12)<<xbest<<"  "<<setw(12)<<fxbest<<"  "<<setw(12)<<pow(pow(xbest-xm,2),0.5)<<"         initial");
+	if (!xIsNan<IssmDouble>(cm_jump) && (xmin==0) && ((fxbest/fxmin)<cm_jump)){
+		if(VerboseControl()) _pprintLine_("      optimization terminated: current x satisfies criteria 'cm_jump'=" << cm_jump);
 		loop=false;
 	}
@@ -154,5 +159,5 @@
 		//evaluate function on x
 		fx = (*f)(x,optargs);
-		if(isnan(fx)) _error_("Function evaluation returned NaN");
+		if(xIsNan<IssmDouble>(fx)) _error2_("Function evaluation returned NaN");
 		iter=iter+1;
 
@@ -179,17 +184,19 @@
 		tol1=seps*pow(pow(xbest,2),0.5)+tolerance/3.0;
 		tol2=2.0*tol1;
-		_printf_(VerboseControl(),"         %5i    %12.6g  %12.6g  %12.6g  %s\n",iter,x,fx,pow(pow(xbest-xm,2),0.5),goldenflag?"       golden":"       parabolic");
+		if(VerboseControl())
+		 _pprintLine_("         "<<setw(5)<<iter<<"    "<<setw(12)<<x<<"  "<<setw(12)<<fx<<"  "<<setw(12)<<pow(pow(xbest-xm,2),0.5)<<
+					 "         "<<(goldenflag?"golden":"parabolic"));
 
 		/*Stop the optimization?*/
 		if (sqrt(pow(xbest-xm,2)) < (tol2-0.5*(xmax-xmin))){
-			_printf_(VerboseControl(),"      optimization terminated: current x satisfies criteria 'tolx'=%g\n",tolerance);
+			if(VerboseControl()) _pprintLine_("      optimization terminated: current x satisfies criteria 'tolx'=" << tolerance);
 			loop=false;
 		}
 		else if (iter>=maxiter){
-			_printf_(VerboseControl(),"      exiting: Maximum number of iterations has been exceeded  ('maxiter'=%i)\n",maxiter);
+			if(VerboseControl()) _pprintLine_("      exiting: Maximum number of iterations has been exceeded  ('maxiter'=" << maxiter << ")");
 			loop=false;
 		}
-		else if (!isnan(cm_jump) && (xmin==0) && ((fxbest/fxmin)<cm_jump)){
-			_printf_(VerboseControl(),"      optimization terminated: current x satisfies criteria 'cm_jump'=%g\n",cm_jump);
+		else if (!xIsNan<IssmDouble>(cm_jump) && (xmin==0) && ((fxbest/fxmin)<cm_jump)){
+			if(VerboseControl()) _pprintLine_("      optimization terminated: current x satisfies criteria 'cm_jump'=" << cm_jump);
 			loop=false;
 		}
